import { App } from "./App";
import { CancelToken, INameValuePairs } from "./core/types";
export declare class Atom {
    static designMode: boolean;
    static superProperty<T, T2>(tc: T, target: T2, name: keyof T2): any;
    static get(target: any, path: string): any;
    /**
     * Await till given milliseconds have passed
     * @param n
     * @param ct
     */
    static delay(n: number, ct?: CancelToken): Promise<any>;
    static encodeParameters(p: INameValuePairs): string;
    static url(url: string, query?: INameValuePairs, hash?: INameValuePairs): string;
    /**
     * Schedules given call in next available callLater slot and also returns
     * promise that can be awaited, calling `Atom.postAsync` inside `Atom.postAsync`
     * will create deadlock
     * @static
     * @param {()=>Promise<any>} f
     * @returns {Promise<any>}
     * @memberof Atom
     */
    static postAsync(app: App, f: () => Promise<any>): Promise<any>;
}
//# sourceMappingURL=Atom.d.ts.map