(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class AtomEnumerator {
        constructor(items) {
            this.items = items;
            this.index = -1;
        }
        next() {
            this.index++;
            return this.index < this.items.length;
        }
        get current() {
            return this.items[this.index];
        }
        get currentIndex() {
            return this.index;
        }
    }
    exports.default = AtomEnumerator;
});
//# sourceMappingURL=AtomEnumerator.js.map