var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../di/DITransient", "./TransientDisposable", "./types"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const DITransient_1 = require("../di/DITransient");
    const TransientDisposable_1 = require("./TransientDisposable");
    const types_1 = require("./types");
    /**
     * We recommend using CancelTokenFactory instead of using CancelToken directly.
     * This class will cancel previous token before creating new token for given key.
     */
    let CancelTokenFactory = class CancelTokenFactory extends TransientDisposable_1.default {
        constructor() {
            super(...arguments);
            this.mToken = {};
        }
        /**
         * This will create a new token and cancel previous token
         */
        newToken(key, timeout = -1) {
            key = key || "__old";
            const old = this.mToken[key];
            if (old) {
                old.cancel();
            }
            const n = this.mToken[key] = new types_1.CancelToken(timeout);
            return n;
        }
        dispose() {
            for (const key in this.mToken) {
                if (this.mToken.hasOwnProperty(key)) {
                    const element = this.mToken[key];
                    element.dispose();
                }
            }
        }
    };
    CancelTokenFactory = __decorate([
        DITransient_1.default()
    ], CancelTokenFactory);
    exports.default = CancelTokenFactory;
});
//# sourceMappingURL=CancelTokenFactory.js.map