var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../MockApp", "../services/NavigationService", "./AtomTest", "../web/styles/AtomStyleSheet", "../web/styles/AtomTheme"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.MockWebApp = void 0;
    const MockApp_1 = require("../MockApp");
    const NavigationService_1 = require("../services/NavigationService");
    const AtomTest_1 = require("./AtomTest");
    const AtomStyleSheet_1 = require("../web/styles/AtomStyleSheet");
    const AtomTheme_1 = require("../web/styles/AtomTheme");
    class MockWebApp extends MockApp_1.MockApp {
    }
    exports.MockWebApp = MockWebApp;
    class AtomWebTest extends AtomTest_1.AtomTest {
        get navigationService() {
            return this.app.get(NavigationService_1.NavigationService);
        }
        constructor() {
            super(new MockWebApp());
            this.app.put(AtomTheme_1.AtomTheme, this.app.resolve(AtomTheme_1.AtomTheme));
            this.app.put(AtomStyleSheet_1.AtomStyleSheet, this.app.resolve(AtomTheme_1.AtomTheme));
        }
        dispose() {
            return __awaiter(this, void 0, void 0, function* () {
                if (this.navigationService.assert) {
                    this.navigationService.assert();
                }
                yield this.app.waitForPendingCalls();
            });
        }
    }
    exports.default = AtomWebTest;
});
//# sourceMappingURL=AtomWebTest.js.map