(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../core/Colors", "./AtomWindowStyle"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const Colors_1 = require("../../core/Colors");
    const AtomWindowStyle_1 = require("./AtomWindowStyle");
    class AtomAlertWindowStyle extends AtomWindowStyle_1.AtomWindowStyle {
        get titleHost() {
            return Object.assign(Object.assign({}, this.getBaseProperty(AtomAlertWindowStyle, "titleHost")), { color: Colors_1.default.black, backgroundColor: Colors_1.default.white });
        }
        get contentPresenter() {
            return Object.assign(Object.assign({}, this.getBaseProperty(AtomAlertWindowStyle, "contentPresenter")), { padding: "0px 10px 30px 10px", textAlign: "center", color: Colors_1.default.rgba(51, 51, 51) });
        }
        get commandBar() {
            return Object.assign(Object.assign({}, this.getBaseProperty(AtomAlertWindowStyle, "commandBar")), { textAlign: "center", subclasses: {
                    " button": this.buttonStyle,
                    " .yes-button": {
                        backgroundColor: Colors_1.default.rgba(0, 128, 0)
                    },
                    " .no-button": {
                        backgroundColor: Colors_1.default.rgba(255, 0, 0)
                    }
                } });
        }
        get buttonStyle() {
            return {
                border: "none",
                color: Colors_1.default.white,
                width: "50%",
                height: "40px"
            };
        }
    }
    exports.default = AtomAlertWindowStyle;
});
//# sourceMappingURL=AtomAlertWindowStyle.js.map