(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./AtomStyle"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AtomListBoxStyle = void 0;
    const AtomStyle_1 = require("./AtomStyle");
    class AtomListBoxStyle extends AtomStyle_1.AtomStyle {
        get root() {
            return {
                subclasses: {
                    " .item": this.item,
                    " .selected-item": this.selectedItem
                }
            };
        }
        get theme() {
            return this.styleSheet;
        }
        get item() {
            return {
                backgroundColor: this.theme.bgColor,
                color: this.theme.color,
                padding: (this.padding || this.theme.padding) + "px",
                borderRadius: (this.padding || this.theme.padding) + "px",
                cursor: "pointer"
            };
        }
        get selectedItem() {
            return Object.assign(Object.assign({}, this.item), { backgroundColor: this.theme.selectedBgColor, color: this.theme.selectedColor, cursor: "pointer" });
        }
    }
    exports.AtomListBoxStyle = AtomListBoxStyle;
});
//# sourceMappingURL=AtomListBoxStyle.js.map